// Load in modules
const Scene = require("Scene");
const FaceTracking = require("FaceTracking");

(async function () { // Enables async/await in JS [part 1]

  // Fetch array of bones
  const antennaBones = await Scene.root.findByPath("**/Bone*");

  // Create face signals for X axis
  const faceSignalX = FaceTracking.face(0).cameraTransform.x.expSmooth(90);
  const faceSignalX2 = FaceTracking.face(0).cameraTransform.x.expSmooth(100);

  // Create face signals for Y axis
  const faceSignalY = FaceTracking.face(0).cameraTransform.y.expSmooth(90);
  const faceSignalY2 = FaceTracking.face(0).cameraTransform.y.expSmooth(100);

  // Variable to amplify antenna swing
  const scaleFactor = 120;

  // Loop to bind each bone rotation
  antennaBones.forEach(function (bone) {
    // Bind bone Z rotation to head X rotation
    bone.transform.rotationZ = faceSignalX.sub(faceSignalX2).mul(scaleFactor);
    // Bind bone X rotation to head Y rotation
    bone.transform.rotationX = faceSignalY.sub(faceSignalY2).mul(scaleFactor);
  });

})();// Enables async/await in JS [part 2]
